(************************************************************)
(*							    *)
(* ࠭  类 砩 ᫠ 		    *)
(*				   ꪢ  筮 ࢮ *)
(*							    *)
(*	ணࠬ࠭  ࠭  ࣨ . ஢	    *)
(*		(c) 1989 George Petrov /YGP/		    *)
(*							    *)
(*   ࠭  {$define ShowNil}  NIL .   *)
(*							    *)
(************************************************************)

program PrTree; { $define ShowNil}
const
  Nnumbers=17;  {    ⠢ ᫮ -  5000, }
		       {  ⨢ 砩    , }
	      {   ⨣   ꧤ  ࢮ. }
  Hch=''; Uch=''; Dch=''; Xch='';
  Lch=''; Vch=''; Rch='';
  TopRight=''; DownRight='';
type
  TreePtr=^TreeRec;
  TreeRec=record
    left,right:TreePtr;
    Value:word
  end { TreeRec };
var
  Tree:TreePtr;
  i,j:word;
  TreeLevel:integer;
  Put:char;
  Show:string;

procedure Insrt(NewValue:word);
var
  LeftPart:boolean;
  p,InsPtr,NewPtr:TreePtr;
begin
  p:=Tree; InsPtr:=nil;
  while p<>nil do
  begin
    LeftPart:=NewValue<p^.Value; InsPtr:=p;
    if LeftPart then p:=p^.left else p:=p^.right
  end { while };
  new(NewPtr);
  with NewPtr^ do
  begin
    Value:=NewValue; left:=nil; right:=nil
  end { with };
  if InsPtr=nil then Tree:=NewPtr
    else if LeftPart then InsPtr^.left:=NewPtr
      else InsPtr^.right:=NewPtr
end { Insrt };

procedure PrintTree(p:TreePtr);
var
  SavePut,ThisCh:char;
begin
  SavePut:=Put; ThisCh:=Hch; Inc(TreeLevel); Put:=Lch;
  if p<>nil then PrintTree(p^.left);
  Show[TreeLevel]:=SavePut;
  Show[0]:=chr(TreeLevel); { 'patch' string length }
  if p<>nil then
  begin
    {$ifdef ShowNil}
      ThisCh:=Xch;
    {$else}
      if p^.left<>nil then if p^.right<>nil
	then ThisCh:=Xch else ThisCh:=Uch
	  else if p^.right<>nil then ThisCh:=Dch;
    {$endif}
    writeln(Show,ThisCh,p^.Value)
  end
  {$ifdef ShowNil}
    else writeln(Show,ThisCh,'nil')
  {$endif};
  if SavePut=Lch then Show[TreeLevel]:=Vch
    else Show[TreeLevel]:=' ';
  Put:=Rch; if p<>nil then
  begin
    Show[TreeLevel+1]:=Vch; PrintTree(p^.right)
  end;
  Dec(TreeLevel)
end { PrintTree };

begin
  writeln('Creating Binary Tree'); Randomize; Tree:=nil;
  for i:= 1 to Nnumbers do
  begin
    j:=trunc(Random*10);
    write(#13'Inserting ',j:5,' in a tree. ');
    Insrt(j); write(i,' elements inserted.')
  end { for };
  writeln; writeln(Nnumbers, ' numbers inserted.');
  write(Lch:2); for i:=1 to 37 do write(Hch);
  writeln(TopRight);
  writeln(Vch:2,      'Print Binary Tree.': 28,Vch:10);
  writeln(Vch:2,'UniPascal Demonstration Program':34,Vch:4);
  writeln(Lch,Vch,     'by George Petrov':27,Vch:11);
  writeln(Vch,Vch, '(c) 1989 Software R&D Lab.':32,Vch:6);
  write(Vch,Rch); for i:=1 to 37 do write(Hch);
  writeln(DownRight);
  TreeLevel:=0; FillChar(Show,SizeOf(Show),' ');
  Show[1]:=Vch; Put:=Rch; PrintTree(Tree)
end { PrTree }.